/* Virtual Reality: MFuncGetName.cpp
   =============================================================================

   This file contains the functions needed to determine the name of a MFunc. For
   some functions that access hardware at a low lever, or that occur very often
   in programs, we may want/need to check if we know that function. If it is
   known it may not be necessary to recompile that function.
   
   12-12-2000 First release
*/

#include "MFuncGetName.h"

/* Given a MFunc, this function returns a String with the name of the function.
   When the function is unknown it returns "Unknown".
*/
char *MFunc_GetName(MFunc Func)
{
	return "Unknown";
}
