/* Virtual Reality: Test.cpp
   =============================================================================

   This is just a stupid program to test the basic stuff. It loads N64Stars.v64
   in memory and asks for the function at some address.

   12-12-2000 First release
*/

#include "MTypes.h"
#include "MFunc.h"

#include <stdio.h>
#include <malloc.h>

void main(void)
{
	char *Rom;
	
	/* Load the rom in memory */
	FILE *RomPointer;
	RomPointer = fopen("N64Stars.v64", "rb");
	fseek(RomPointer, 0, SEEK_END);
	int Size = ftell(RomPointer);
	fseek(RomPointer, 0, SEEK_SET);
	Rom = (char *) malloc(Size);
	fread(Rom, 1, Size, RomPointer);
	fclose(RomPointer);
    
	/* It might need some corrections */
	if (((uHword *)Rom)[0] == 0x3780)
	{
		for (uWord Index = 0; Index < Size; Index += 4)
		{
			uByte Temp1;
			uByte Temp2;
			uByte Temp3;

			Temp1 = Rom[Index];
			Temp2 = Rom[Index + 1];
			Temp3 = Rom[Index + 2];
			Rom[Index] = Rom[Index + 3];
			Rom[Index + 1] = Temp3;
			Rom[Index + 2] = Temp2;
			Rom[Index + 3] = Temp1;
		}
	}
	else if (((uHword *)Rom)[0] == 0x8037)
	{
		uHword Temp;

		for (uWord Index = 0; Index < (Size >> 1); Index += 2)
		{
			Temp = ((uHword *)Rom)[Index];

			((uHword *)Rom)[Index] = ((uHword *)Rom)[Index + 1];
			((uHword *)Rom)[Index + 1] = Temp;
		}
	}
	else
	{
		// validation word unknown
	}    
    
    /* Get a mipsfunction from address Rom + 0x1000 + 0x000 and assign 
	   offset 0x80200000 to the first instruction */
	MFunc Func = MFunc_GetFunction(0x80200000, Rom + 0x1000 + 0x000);
	/* Print the function */
	MFunc_Print(Func);
}
